scala.tools.nsc.backend.jvm.BTypes

# ClassBType

###
Related Docs: object ClassBType | package BTypes

#### final case class ClassBType(internalName: InternalName) extends RefBType with Product with Serializable

A ClassBType represents a class or interface type. The necessary information to build a ClassBType is extracted from compiler symbols and types, see BTypesFromSymbols.

Source
  BTypes.scala

Linear Supertypes
Serializable, java.io.Serializable, Product, Equals, RefBType, BType, AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. ClassBType
2. Serializable
3. Serializable
4. Product
5. Equals
6. RefBType
7. BType
8. AnyRef
9. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new ClassBType(internalName: InternalName)

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from ClassBType to any2stringadd[ClassBType] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (ClassBType, B)

   Implicit information
     This member is added by an implicit conversion from ClassBType to ArrowAssoc[ClassBType] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### def asArrayBType: ArrayBType

   Definition Classes
     BType

7. #### def asClassBType: ClassBType

   Definition Classes
     BType

8. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

9. #### def asPrimitiveBType: PrimitiveBType

   Definition Classes
     BType

10. #### def asRefBType: RefBType

    Definition Classes
      BType

11. #### def classOrArrayType: String

    The class or array type of this reference type.

    The class or array type of this reference type. Used for ANEWARRAY, MULTIANEWARRAY, INSTANCEOF and CHECKCAST instructions. Also used for emitting invokevirtual calls to (a: Array[T]).clone() for any T, see genApply.

    In contrast to the descriptor, this string does not contain the surrounding 'L' and ';' for class types, for example "java/lang/String". However, for array types, the full descriptor is used, for example "[Ljava/lang/String;".

    This can be verified for example using javap or ASMifier.

    Definition Classes
      RefBType

12. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

13. #### final def conformsTo(other: BType): Boolean

    Definition Classes
      BType

14. #### final def descriptor: String

    returns

      The Java descriptor of this type. Examples:

      - int: I
      - java.lang.String: Ljava/lang/String;
      - int[]: [I
      - Object m(String s, double d): (Ljava/lang/String;D)Ljava/lang/Object;
    Definition Classes
      BType

15. #### def enclosingNestedClassesChain: List[ClassBType]

16. #### def ensuring(cond: (ClassBType) ⇒ Boolean, msg: ⇒ Any): ClassBType

    Implicit information
      This member is added by an implicit conversion from ClassBType to Ensuring[ClassBType] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

17. #### def ensuring(cond: (ClassBType) ⇒ Boolean): ClassBType

    Implicit information
      This member is added by an implicit conversion from ClassBType to Ensuring[ClassBType] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

18. #### def ensuring(cond: Boolean, msg: ⇒ Any): ClassBType

    Implicit information
      This member is added by an implicit conversion from ClassBType to Ensuring[ClassBType] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

19. #### def ensuring(cond: Boolean): ClassBType

    Implicit information
      This member is added by an implicit conversion from ClassBType to Ensuring[ClassBType] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

20. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

21. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

22. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from ClassBType to StringFormat[ClassBType] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

23. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

24. #### def info: ClassInfo

25. #### def info_=(i: ClassInfo): Unit

26. #### def innerClassAttributeEntry: Option[InnerClassEntry]

27. #### val internalName: InternalName

28. #### final def isArray: Boolean

    Definition Classes
      BType

29. #### final def isBoxed: Boolean

    Definition Classes
      BType

30. #### final def isClass: Boolean

    Definition Classes
      BType

31. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

32. #### final def isIntSizedType: Boolean

    Definition Classes
      BType

33. #### final def isIntegralType: Boolean

    Definition Classes
      BType

34. #### def isInterface: Boolean

35. #### final def isMethod: Boolean

    Definition Classes
      BType

36. #### def isNestedClass: Boolean

37. #### final def isNonVoidPrimitiveType: Boolean

    Definition Classes
      BType

38. #### final def isNothingType: Boolean

    Definition Classes
      BType

39. #### final def isNullType: Boolean

    Definition Classes
      BType

40. #### final def isNumericType: Boolean

    Definition Classes
      BType

41. #### final def isPrimitive: Boolean

    Definition Classes
      BType

42. #### final def isRealType: Boolean

    Definition Classes
      BType

43. #### final def isRef: Boolean

    Definition Classes
      BType

44. #### def isSubtypeOf(other: ClassBType): Boolean

45. #### final def isWideType: Boolean

    Definition Classes
      BType

46. #### def jvmWiseLUB(other: ClassBType): ClassBType

    Finding the least upper bound in agreement with the bytecode verifier Background: http://gallium.inria.fr/~xleroy/publi/bytecode-verification-JAR.pdf http://comments.gmane.org/gmane.comp.java.vm.languages/2293 https://issues.scala-lang.org/browse/SI-3872

47. #### final def maxType(other: BType): BType

    Compute the upper bound of two types.

    Compute the upper bound of two types. Takes promotions of numeric primitives into account.

    Definition Classes
      BType

48. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

49. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

50. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

51. #### def simpleName: String

    returns

      The class name without the package prefix

52. #### final def size: Int

    returns

      0 for void, 2 for long and double, 1 otherwise

    Definition Classes
      BType

53. #### def superClassesTransitive: List[ClassBType]

54. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

55. #### def toASMType: Type

    The asm.Type corresponding to this BType.

    The asm.Type corresponding to this BType.

    Note about asm.Type.getObjectType (*): For class types, the method expects the internal name, i.e. without the surrounding 'L' and ';'. For array types on the other hand, the method expects a full descriptor, for example "[Ljava/lang/String;".

    See method asm.Type.getType that creates a asm.Type from a type descriptor

    - for an OBJECT type, the 'L' and ';' are not part of the range of the created Type
    - for an ARRAY type, the full descriptor is part of the range
    Definition Classes
      BType

56. #### final def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      BType → AnyRef → Any

57. #### final def typedOpcode(opcode: Int): Int

    Some JVM opcodes have typed variants.

    Some JVM opcodes have typed variants. This method returns the correct opcode according to the type.

    opcode

      A JVM instruction opcode. This opcode must be one of ILOAD, ISTORE, IALOAD, IASTORE, IADD, ISUB, IMUL, IDIV, IREM, INEG, ISHL, ISHR, IUSHR, IAND, IOR IXOR and IRETURN.

    returns

      The opcode adapted to this java type. For example, if this type is `float` and `opcode` is `IRETURN`, this method returns `FRETURN`.

    Definition Classes
      BType

58. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

59. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

60. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

61. #### def →[B](y: B): (ClassBType, B)

    Implicit information
      This member is added by an implicit conversion from ClassBType to ArrowAssoc[ClassBType] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from Serializable

### Inherited from java.io.Serializable

### Inherited from Product

### Inherited from Equals

### Inherited from RefBType

### Inherited from BType

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from ClassBType to any2stringadd[ClassBType]

### Inherited by implicit conversion StringFormat from ClassBType to StringFormat[ClassBType]

### Inherited by implicit conversion Ensuring from ClassBType to Ensuring[ClassBType]

### Inherited by implicit conversion ArrowAssoc from ClassBType to ArrowAssoc[ClassBType]

### Ungrouped